#ifndef INCLUDED_OFFICECFG_OFFICE_PATHS_HXX
#define INCLUDED_OFFICECFG_OFFICE_PATHS_HXX

#include "sal/config.h"

#include <optional>
#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace Office { namespace Paths {

struct Paths: public comphelper::ConfigurationSet< Paths> {
    static OUString path() { static constexpr OUString PATH(u"/org.openoffice.Office.Paths/Paths"_ustr); return PATH; }
private:
    Paths(); // not defined
    ~Paths(); // not defined
};

struct Variables: public comphelper::ConfigurationGroup< Variables> {
    static OUString path() { static constexpr OUString PATH(u"/org.openoffice.Office.Paths/Variables"_ustr); return PATH; }

struct Work: public comphelper::ConfigurationProperty<Work, std::optional<OUString> > {
    static OUString path() { static constexpr OUString PATH(u"/org.openoffice.Office.Paths/Variables/Work"_ustr); return PATH; }
private:
    Work(); // not defined
    ~Work(); // not defined
};

private:
    Variables(); // not defined
    ~Variables(); // not defined
};

} } }

#endif
